SystemOrganization addCategory: #'Meta-Implementation'!

Compiler subclass: #MMetaCompiler
	instanceVariableNames: ''
	classVariableNames: 'UseBootstrap'
	poolDictionaries: ''
	category: 'Meta-Implementation'!

!MMetaCompiler class methodsFor: 'as yet unclassified' stamp: 'yo 5/1/2007 19:49'!
metaProductionName: aString

	| ind separators n |
	ind _ 1.
	separators _ Character separators.
	ind _ aString findDelimiters: (separators copyWith: $:) startingAt: ind.
	ind > aString size ifTrue: [^ nil].
	n _ aString copyFrom: 1 to: ind-1.
	ind _ aString skipDelimiters: separators startingAt: ind.
	ind > aString size ifTrue: [^ nil].
	ind + 2 > aString size ifTrue: [^ nil].
	^ (aString copyFrom: ind to: ind+2) = '::='ifTrue: [n] ifFalse: [nil].
! !

!MMetaCompiler class methodsFor: 'as yet unclassified' stamp: 'aw 3/1/2007 11:56'!
useBootstrap: aBoolean

	UseBootstrap _ aBoolean.
! !

!MMetaCompiler methodsFor: 'public access' stamp: 'tfel 8/5/2016 12:57'!
compile: origCode in: cls notifying: notify ifFail: failBlock

	| prodName tree translatedTree translatedCode sourceStream |
	(origCode isKindOf: PositionableStream)
		ifTrue: [sourceStream _ origCode]
		ifFalse: [sourceStream _ ReadStream on: origCode asString].

	(prodName _ MMetaCompiler metaProductionName: sourceStream contents)
		ifNil: [^ super compile: origCode in: cls notifying: notify ifFail: failBlock].
	cls prepareForNewProduction.
	tree _ (self useBootstrap ifTrue: [MBootstrapMetaParser] ifFalse: [MMetaParser]) parse: origCode with: #mDef.
	tree ifNil: [self error: 'syntax error in ', prodName].
	cls addSupportForProduction: prodName.
	translatedTree _ cls expand: tree.
	translatedCode _ cls generateProduction: prodName withBody: translatedTree.
	^ super compile: translatedCode in: cls notifying: notify ifFail: failBlock
! !

!MMetaCompiler methodsFor: 'public access' stamp: 'tfel 8/5/2016 15:46'!
useBootstrap

	^ UseBootstrap ifNil: [true]
! !

Object subclass: #MMatcher
	instanceVariableNames: 'stream pos posStack anythingMemo anythingNextPos'
	classVariableNames: 'Untried'
	poolDictionaries: ''
	category: 'Meta-Implementation'!

MMatcher class
	instanceVariableNames: 'userDefinedVars tmpIndex'!

MMatcher class
	instanceVariableNames: 'userDefinedVars tmpIndex'!

MMatcher subclass: #MBootstrapParser
	instanceVariableNames: 'endMemo charMemo charNextPos endNextPos spaceMemo spaceNextPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Implementation'!

MBootstrapParser subclass: #MBootstrapMetaParser
	instanceVariableNames: 'mExpr1Memo mExpr1NextPos mDefMemo mDefNextPos mExpr2Memo mExpr2NextPos mExpr3Memo mExpr3NextPos mExpr4Memo mExpr4NextPos mExprMemo mExprNextPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Implementation'!

!MBootstrapMetaParser class methodsFor: 'bootstrap' stamp: 'yo 5/6/2007 18:32'!
generateMDef
"
	self generateMDef
"
	| body |
	self prepareForNewProduction.
	body _ self expand: {#macroOr:.
		{#macroAnd:.
			{#macroBind:. 'n'. {#macroApp:. 'anything'}}. {#macroPred:. 'n is: #name'}.
			{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #''::='''}.
			{#macroBind:. 'v'. {#macroApp:. 'mExpr'}}.
			{#macroNot:. {#macroApp:. 'anything'}}.
			{#macroAns:. '{#macroDef:. n value asString. v}'}
		}
	}.
	self addProduction: 'mDef' withBody: body.
! !

!MBootstrapMetaParser class methodsFor: 'bootstrap' stamp: 'aw 2/18/2007 18:19'!
generateMExpr
"
	self generateMExpr
"
	| body |
	self prepareForNewProduction.
	body _ self expand:
		{#macroOr:.
			{#macroAnd:.
				{#macroBind:. 'x'. {#macroApp:. 'mExpr4'}}.
				{#macroBind:. 'xs'.
					{#macroMany:.
						{#macroOr:.
							{#macroAnd:.
								{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #|'}.
								{#macroApp:. 'mExpr4'}
							}
						}
					}
				}.
				{#macroAns:. '(Array with: #macroOr: with: x), xs'}
			}
		}.
	self addProduction: 'mExpr' withBody: body.! !

!MBootstrapMetaParser class methodsFor: 'bootstrap' stamp: 'aw 3/1/2007 11:41'!
generateMExpr1
"
	self generateMExpr1
"
	| body |
	self prepareForNewProduction.
	body _ self expand:
		{#macroOr:.
			{#macroAnd:.			
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #<'}.
				{#macroBind:. 'n'. {#macroApp:. 'anything'}}. {#macroPred:. 'n is: #name'}.
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #>'}.
				{#macroAns:. '{#macroApp:. n value asString}'}
			}.
			{#macroAnd:.
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't isReallyString'}.
				{#macroAns:. '{#macroString:. t}'}
			}.
			{#macroAnd:.
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't is: #symbol'}.
				{#macroAns:. '{#macroSymbol:. t value}'}
			}.
			{#macroAnd:.
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't isCharacter'}.
				{#macroAns:. '{#macroCharacter:. t}'}
			}.
			{#macroAnd:.
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't isInterval'}.
				{#macroAns:. '{#macroInterval:. t}'}
			}.
			{#macroAnd:.
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #?'}.
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't is: #code'}.
				{#macroAns:. '{#macroPred:. t value}'}
			}.				
			{#macroAnd:.
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't is: #code'}.
				{#macroAns:. '{#macroAns:. t value}'}
			}.
			{#macroAnd:.
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #''('''}.
				{#macroBind:. 'r'. {#macroApp:. 'mExpr'}}.
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #'')'''}.
				{#macroAns:. 'r'}
			}
		}.
	self addProduction: 'mExpr1' withBody: body.
! !

!MBootstrapMetaParser class methodsFor: 'bootstrap' stamp: 'yo 5/5/2007 14:53'!
generateMExpr2
"
	self generateMExpr2
"
	| body |
	self prepareForNewProduction.
	body _ self expand:
		{#macroOr:.
			{#macroAnd:.
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #~'}.
				{#macroBind:. 'e'. {#macroApp:. 'mExpr2'}}. {#macroAns:. '{#macroNot:. e}'}
			}.
			{#macroAnd:.
				{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #&'}.
				{#macroBind:. 'e'. {#macroApp:. 'mExpr2'}}. {#macroAns:. '{#macroAndP:. e}'}
			}.
			{#macroAnd:. {#macroApp:. 'mExpr1'}}
		}.
	self addProduction: 'mExpr2' withBody: body.
! !

!MBootstrapMetaParser class methodsFor: 'bootstrap' stamp: 'aw 3/1/2007 12:32'!
generateMExpr3
"
	self generateMExpr3
"
	| body |
	self prepareForNewProduction.
	body _ self expand:
		{#macroOr:.
			{#macroAnd:.
				{#macroBind:. 'r'. {#macroApp:. 'mExpr2'}}.
				{#macroOr:.
					{#macroAnd:.
						{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #*'}.
						{#macroBind:. 'r'. {#macroQuote:. '{#macroMany:. r}'}}
					}.
					{#macroAnd:.
						{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #+'}.
						{#macroBind:. 'r'. {#macroQuote:. '{#macroMany1:. r}'}}
					}.
					{#macroAnd:. {#macroAns:. 'true'}}
				}.
				{#macroMany:.
					{#macroAnd:.
						{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #''=>'''}.
						{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #<'}.
						{#macroBind:. 'n'. {#macroApp:. 'anything'}}. {#macroPred:. 'n is: #name'}.
						{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #>'}.
						{#macroBind:. 'r'. {#macroQuote:. '{#macroForm:. r. n value asString}'}}.
					}.
				}.
				{#macroOr:.
					{#macroAnd:.
						{#macroBind:. 't'. {#macroApp:. 'anything'}}. {#macroPred:. 't = #:'}.
						{#macroBind:. 'n'. {#macroApp:. 'anything'}}. {#macroPred:. 'n is: #name'}.
						{#macroBind:. 'r'. {#macroAns:. '{#macroBind:. n value asString. r}'}}
					}.
					{#macroAnd:. {#macroAns:. 'true'}}
				}.
				{#macroAns:. 'r'}
			}
		}.
	self addProduction: 'mExpr3' withBody: body.! !

!MBootstrapMetaParser class methodsFor: 'bootstrap' stamp: 'aw 2/18/2007 14:40'!
generateMExpr4
"
	self generateMExpr4
"
	| body |
	self prepareForNewProduction.
	body _ self expand:
		{#macroOr:.
			{#macroAnd:.
				{#macroBind:. 'r'. {#macroMany1:. {#macroApp:. 'mExpr3'}}}. {#macroAns:. '((Array with: #macroAnd:), r)'}
			}
		}.
	self addProduction: 'mExpr4' withBody: body.! !

!MBootstrapMetaParser class methodsFor: 'grammar handling' stamp: 'aw 2/20/2007 17:53'!
tokenizer
	^ MBootstrapMetaTokenizer! !

!MBootstrapMetaParser methodsFor: 'initializers' stamp: 'meta-auto 6/28/2007 21:44'!
initializemDef
	mDefMemo _ Array new: stream size + 1 withAll: Untried.
	mDefNextPos _ Array new: stream size + 1! !

!MBootstrapMetaParser methodsFor: 'initializers' stamp: 'yo 2/28/2007 21:16'!
initializemExpr
	mExprMemo _ Array new: stream size + 1 withAll: Untried.
	mExprNextPos _ Array new: stream size + 1! !

!MBootstrapMetaParser methodsFor: 'initializers' stamp: 'aw 3/1/2007 11:41'!
initializemExpr1
	mExpr1Memo _ Array new: stream size + 1 withAll: Untried.
	mExpr1NextPos _ Array new: stream size + 1! !

!MBootstrapMetaParser methodsFor: 'initializers' stamp: 'meta-auto 6/28/2007 21:44'!
initializemExpr2
	mExpr2Memo _ Array new: stream size + 1 withAll: Untried.
	mExpr2NextPos _ Array new: stream size + 1! !

!MBootstrapMetaParser methodsFor: 'initializers' stamp: 'yo 3/1/2007 14:29'!
initializemExpr3
	mExpr3Memo _ Array new: stream size + 1 withAll: Untried.
	mExpr3NextPos _ Array new: stream size + 1! !

!MBootstrapMetaParser methodsFor: 'initializers' stamp: 'yo 2/28/2007 21:12'!
initializemExpr4
	mExpr4Memo _ Array new: stream size + 1 withAll: Untried.
	mExpr4NextPos _ Array new: stream size + 1! !

!MBootstrapMetaParser methodsFor: 'productions' stamp: 'meta-auto 6/28/2007 21:44'!
mDef
		| oldPos ans v n t horribleTrick |
		oldPos _ pos.
		(ans _ mDefMemo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (n _ self anything)) notNil and: [(ans _ ((n is: #name) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #'::=') ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (v _ self mExpr)) notNil and: [(ans _ [self savePos. (self anything)  ifNotNil: [self discardPos. nil] ifNil: [self restorePos; discardPos. true]] value) notNil and: [(ans _ {#macroDef:. n value asString. v}) notNil]]]]]]]) ifTrue: [ans] ifFalse: [nil]) notNil]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					mDefMemo at: oldPos put: ans.
					mDefNextPos at: oldPos put: pos]
			ifFalse: [pos _ mDefNextPos at: oldPos].
		^ ans! !

!MBootstrapMetaParser methodsFor: 'productions' stamp: 'yo 2/28/2007 21:16'!
mExpr
		| oldPos ans t xs x horribleTrick |
		oldPos _ pos.
		(ans _ mExprMemo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (x _ self mExpr4)) notNil and: [(ans _ (xs _ [| tmp1 | tmp1 _ OrderedCollection new. [self savePos. (ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #|) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ self mExpr4) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value) notNil] whileTrue: [self discardPos. tmp1 addLast: ans]. self restorePos; discardPos. ans _ tmp1 asArray] value)) notNil and: [(ans _ (Array with: #macroOr: with: x), xs) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					mExprMemo at: oldPos put: ans.
					mExprNextPos at: oldPos put: pos]
			ifFalse: [pos _ mExprNextPos at: oldPos].
		^ ans! !

!MBootstrapMetaParser methodsFor: 'productions' stamp: 'aw 3/1/2007 11:41'!
mExpr1
		| oldPos ans t n r horribleTrick |
		oldPos _ pos.
		(ans _ mExpr1Memo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #<) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (n _ self anything)) notNil and: [(ans _ ((n is: #name) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #>) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ {#macroApp:. n value asString}) notNil]]]]]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t isReallyString) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ {#macroString:. t}) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t is: #symbol) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ {#macroSymbol:. t value}) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t isCharacter) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ {#macroCharacter:. t}) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t isInterval) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ {#macroInterval:. t}) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #?) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t is: #code) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ {#macroPred:. t value}) notNil]]]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t is: #code) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ {#macroAns:. t value}) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #'(') ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (r _ self mExpr)) notNil and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #')') ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ r) notNil]]]]]]) ifTrue: [ans] ifFalse: [nil]) notNil]]]]]]]]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					mExpr1Memo at: oldPos put: ans.
					mExpr1NextPos at: oldPos put: pos]
			ifFalse: [pos _ mExpr1NextPos at: oldPos].
		^ ans! !

!MBootstrapMetaParser methodsFor: 'productions' stamp: 'meta-auto 6/28/2007 21:44'!
mExpr2
		| oldPos ans t e horribleTrick |
		oldPos _ pos.
		(ans _ mExpr2Memo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #~) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (e _ self mExpr2)) notNil and: [(ans _ {#macroNot:. e}) notNil]]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #&) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (e _ self mExpr2)) notNil and: [(ans _ {#macroAndP:. e}) notNil]]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ self mExpr1) notNil]) ifTrue: [ans] ifFalse: [nil]) notNil]]]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					mExpr2Memo at: oldPos put: ans.
					mExpr2NextPos at: oldPos put: pos]
			ifFalse: [pos _ mExpr2NextPos at: oldPos].
		^ ans! !

!MBootstrapMetaParser methodsFor: 'productions' stamp: 'yo 3/1/2007 14:29'!
mExpr3
		| oldPos ans t n r horribleTrick |
		oldPos _ pos.
		(ans _ mExpr3Memo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (r _ self mExpr2)) notNil and: [(ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #*) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (r _ {#macroMany:. r})) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #+) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (r _ {#macroMany1:. r})) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ true) notNil]) ifTrue: [ans] ifFalse: [nil]) notNil]]]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value) notNil and: [(ans _ [| tmp1 | tmp1 _ OrderedCollection new. [self savePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #'=>') ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #<) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (n _ self anything)) notNil and: [(ans _ ((n is: #name) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #>) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (r _ {#macroForm:. r. n value asString})) notNil]]]]]]]]]) ifTrue: [ans] ifFalse: [nil]) notNil] whileTrue: [self discardPos. tmp1 addLast: ans]. self restorePos; discardPos. ans _ tmp1 asArray] value) notNil and: [(ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (t _ self anything)) notNil and: [(ans _ ((t = #:) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (n _ self anything)) notNil and: [(ans _ ((n is: #name) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (r _ {#macroBind:. n value asString. r})) notNil]]]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ true) notNil]) ifTrue: [ans] ifFalse: [nil]) notNil]]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value) notNil and: [(ans _ r) notNil]]]]]) ifTrue: [ans] ifFalse: [nil]) notNil]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					mExpr3Memo at: oldPos put: ans.
					mExpr3NextPos at: oldPos put: pos]
			ifFalse: [pos _ mExpr3NextPos at: oldPos].
		^ ans! !

!MBootstrapMetaParser methodsFor: 'productions' stamp: 'yo 2/28/2007 21:12'!
mExpr4
		| oldPos ans r horribleTrick |
		oldPos _ pos.
		(ans _ mExpr4Memo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (r _ ((ans _ self mExpr3) notNil ifTrue: [| tmp1 | tmp1 _ OrderedCollection with: ans. [self savePos. (ans _ self mExpr3) notNil] whileTrue: [self discardPos. tmp1 addLast: ans]. self restorePos; discardPos. ans _ tmp1 asArray] ifFalse: [nil]))) notNil and: [(ans _ ((Array with: #macroAnd:), r)) notNil]]) ifTrue: [ans] ifFalse: [nil]) notNil]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					mExpr4Memo at: oldPos put: ans.
					mExpr4NextPos at: oldPos put: pos]
			ifFalse: [pos _ mExpr4NextPos at: oldPos].
		^ ans! !

MBootstrapParser subclass: #MBootstrapMetaTokenizer
	instanceVariableNames: 'metaSpecialMemo metaSpecialNextPos metaCharMemo metaCharNextPos metaTokenMemo metaTokenNextPos metaStringMemo metaStringNextPos metaNameMemo metaNameNextPos metaCodeMemo metaCodeNextPos tokenizeMemo tokenizeNextPos metaSymbolMemo metaSymbolNextPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Implementation'!

!MBootstrapMetaTokenizer class methodsFor: 'bootstrap' stamp: 'aw 2/18/2007 14:30'!
generateMetaChar
"
	self generateMetaChar
"
	| body |
	self prepareForNewProduction.
	body _ self expand: {#macroOr:.
		{#macroAnd:.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $$'}.
			{#macroBind:. 'c1'. {#macroApp:. 'char'}}.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $.'}.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $.'}.
			{#macroBind:. 'c2'. {#macroApp:. 'char'}}.
			{#macroAns:. '(Interval from: c1 to: c2)'}
		}.
		{#macroAnd:.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $$'}.
			{#macroApp:. 'char'}.
		}
	}.
	self addProduction: 'metaChar' withBody: body.
! !

!MBootstrapMetaTokenizer class methodsFor: 'bootstrap' stamp: 'yo 2/28/2007 21:08'!
generateMetaCode
"
	self generateMetaCode
"
	| body |
	self prepareForNewProduction.
	body _ self expand: {#macroOr:.
		{#macroAnd:.  
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $`'}.
			{#macroBind:. 's'. {#macroMany:. {#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c ~= $`'}. {#macroAns:. 'c'}}}}.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $`'}.
			{#macroAns:. 'MToken type: #code value: (String newFrom: s)'}
		}
	}.
	self addProduction: 'metaCode' withBody: body.
! !

!MBootstrapMetaTokenizer class methodsFor: 'bootstrap' stamp: 'yo 2/28/2007 21:08'!
generateMetaName
"
	self generateMetaName
"
	| body |
	self prepareForNewProduction.
	body _ self expand: {#macroOr:.
		{#macroAnd:.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c isLetter'}.
			{#macroBind:. 's'. {#macroMany:. {#macroAnd:. {#macroBind:. 'd'. {#macroApp:. 'char'}}. {#macroPred:. 'd isAlphaNumeric'}. {#macroAns:. 'd'}}}}.
			{#macroAns:. 'MToken type: #name value: (String newFrom: c asString, s)'}
		}
	}.
	self addProduction: 'metaName' withBody: body.
! !

!MBootstrapMetaTokenizer class methodsFor: 'bootstrap' stamp: 'yo 5/6/2007 19:00'!
generateMetaSpecial
"
	self generateMetaSpecial
"
	| body |
	self prepareForNewProduction.
	body _ self expand: {#macroOr:.
		{#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $<'}. {#macroAns:. '#<'}}.
		{#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $>'}. {#macroAns:. '#>'}}.
		{#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $?'}. {#macroAns:. '#?'}}.
		{#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $('}. {#macroAns:. '#''('''}}.
		{#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $)'}. {#macroAns:. '#'')'''}}.
		{#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $~'}. {#macroAns:. '#~'}}.
		{#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $&'}. {#macroAns:. '#&'}}.
		{#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $*'}. {#macroAns:. '#*'}}.
		{#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $+'}. {#macroAns:. '#+'}}.
		{#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $|'}. {#macroAns:. '#|'}}.
		{#macroAnd:.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $:'}.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $:'}.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $='}.
			{#macroAns:. '#''::='''}.
		}.
		{#macroAnd:.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $='}.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $>'}.
			{#macroAns:. '#''=>'''}.
		}.
		{#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $:'}. {#macroAns:. '#:'}}
	}.
	self addProduction: 'metaSpecial' withBody: body.
! !

!MBootstrapMetaTokenizer class methodsFor: 'bootstrap' stamp: 'aw 2/18/2007 14:33'!
generateMetaString
"
	self generateMetaString
"
	| body |
	self prepareForNewProduction.
	body _ self expand: {#macroOr:.
		{#macroAnd:.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $'''}.
			{#macroBind:. 's'. {#macroMany:. {#macroAnd:. {#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c ~= $'''}. {#macroAns:. 'c'}}}}.
			{#macroBind:. 'c'. {#macroApp:. 'char'}}. {#macroPred:. 'c = $'''}.
			{#macroAns:. '(String newFrom: s)'}
		}
	}.
	self addProduction: 'metaString' withBody: body.
! !

!MBootstrapMetaTokenizer class methodsFor: 'bootstrap' stamp: 'yo 2/28/2007 22:55'!
generateMetaSymbol
"
	self generateMetaSymbol
"
	| body |
	self prepareForNewProduction.
	body _ self expand: {#macroOr:.
		{#macroAnd:. {#macroString:. '#'}. {#macroBind:. 'n'. {#macroApp:. 'metaName'}}. {#macroAns:. 'MToken type: #symbol value: n value'}}.
		{#macroAnd:. {#macroString:. '#'}. {#macroBind:. 's'. {#macroApp:. 'metaString'}}. {#macroAns:. 'MToken type: #symbol value: (Symbol newFrom: s)'}}.
	}.
	self addProduction: 'metaSymbol' withBody: body.
! !

!MBootstrapMetaTokenizer class methodsFor: 'bootstrap' stamp: 'aw 2/19/2007 10:09'!
generateMetaToken
"
	self generateMetaToken
"
	| body |
	self prepareForNewProduction.
	body _ self expand: {#macroOr:.
		{#macroAnd:.
			{#macroMany:. {#macroApp:. 'space'}}.
			{#macroOr:.
				{#macroApp:. 'metaSpecial'}.
				{#macroApp:. 'metaChar'}.
				{#macroApp:. 'metaString'}.
				{#macroApp:. 'metaSymbol'}.
				{#macroApp:. 'metaName'}.
				{#macroApp:. 'metaCode'}.
			}
		}
	}.
	self addProduction: 'metaToken' withBody: body.
! !

!MBootstrapMetaTokenizer class methodsFor: 'bootstrap' stamp: 'yo 5/6/2007 18:25'!
generateTokenize
"
	self generateTokenize
"
	| body |
	self prepareForNewProduction.
	body _ self expand: {#macroOr:.
		{#macroAnd:. {#macroMany:. {#macroApp:. 'metaToken'}}}}.
	self addProduction: 'tokenize' withBody: body.
! !

!MBootstrapMetaTokenizer methodsFor: 'initializers' stamp: 'yo 2/28/2007 21:15'!
initializemetaChar
	metaCharMemo _ Array new: stream size + 1 withAll: Untried.
	metaCharNextPos _ Array new: stream size + 1! !

!MBootstrapMetaTokenizer methodsFor: 'initializers' stamp: 'yo 2/28/2007 21:15'!
initializemetaCode
	metaCodeMemo _ Array new: stream size + 1 withAll: Untried.
	metaCodeNextPos _ Array new: stream size + 1! !

!MBootstrapMetaTokenizer methodsFor: 'initializers' stamp: 'yo 2/28/2007 21:15'!
initializemetaName
	metaNameMemo _ Array new: stream size + 1 withAll: Untried.
	metaNameNextPos _ Array new: stream size + 1! !

!MBootstrapMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 6/28/2007 21:44'!
initializemetaSpecial
	metaSpecialMemo _ Array new: stream size + 1 withAll: Untried.
	metaSpecialNextPos _ Array new: stream size + 1! !

!MBootstrapMetaTokenizer methodsFor: 'initializers' stamp: 'yo 2/28/2007 21:15'!
initializemetaString
	metaStringMemo _ Array new: stream size + 1 withAll: Untried.
	metaStringNextPos _ Array new: stream size + 1! !

!MBootstrapMetaTokenizer methodsFor: 'initializers' stamp: 'yo 2/28/2007 21:15'!
initializemetaSymbol
	metaSymbolMemo _ Array new: stream size + 1 withAll: Untried.
	metaSymbolNextPos _ Array new: stream size + 1! !

!MBootstrapMetaTokenizer methodsFor: 'initializers' stamp: 'yo 2/28/2007 21:15'!
initializemetaToken
	metaTokenMemo _ Array new: stream size + 1 withAll: Untried.
	metaTokenNextPos _ Array new: stream size + 1! !

!MBootstrapMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 6/28/2007 21:44'!
initializetokenize
	tokenizeMemo _ Array new: stream size + 1 withAll: Untried.
	tokenizeNextPos _ Array new: stream size + 1! !

!MBootstrapMetaTokenizer methodsFor: 'productions' stamp: 'yo 2/28/2007 21:15'!
metaChar
		| oldPos ans c c2 c1 horribleTrick |
		oldPos _ pos.
		(ans _ metaCharMemo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $$) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (c1 _ self char)) notNil and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $.) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $.) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (c2 _ self char)) notNil and: [(ans _ (Interval from: c1 to: c2)) notNil]]]]]]]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $$) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ self char) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil]]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					metaCharMemo at: oldPos put: ans.
					metaCharNextPos at: oldPos put: pos]
			ifFalse: [pos _ metaCharNextPos at: oldPos].
		^ ans! !

!MBootstrapMetaTokenizer methodsFor: 'productions' stamp: 'yo 2/28/2007 21:15'!
metaCode
		| oldPos ans c s horribleTrick |
		oldPos _ pos.
		(ans _ metaCodeMemo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $`) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (s _ [| tmp1 | tmp1 _ OrderedCollection new. [self savePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c ~= $`) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ c) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil] whileTrue: [self discardPos. tmp1 addLast: ans]. self restorePos; discardPos. ans _ tmp1 asArray] value)) notNil and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $`) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ MToken type: #code value: (String newFrom: s)) notNil]]]]]]) ifTrue: [ans] ifFalse: [nil]) notNil]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					metaCodeMemo at: oldPos put: ans.
					metaCodeNextPos at: oldPos put: pos]
			ifFalse: [pos _ metaCodeNextPos at: oldPos].
		^ ans! !

!MBootstrapMetaTokenizer methodsFor: 'productions' stamp: 'tfel 8/5/2016 12:57'!
metaName
		| oldPos ans c d s horribleTrick |
		oldPos _ pos.
		(ans _ metaNameMemo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c isLetter) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (s _ [| tmp1 | tmp1 _ OrderedCollection new. [self savePos. (ans _ (true and: [(ans _ (d _ self char)) notNil and: [(ans _ ((d isAlphaNumeric) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ d) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil] whileTrue: [self discardPos. tmp1 addLast: ans]. self restorePos; discardPos. ans _ tmp1 asArray] value)) notNil and: [(ans _ MToken type: #name value: (String newFrom: c asString, (s joinSeparatedBy: ''))) notNil]]]]) ifTrue: [ans] ifFalse: [nil]) notNil]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					metaNameMemo at: oldPos put: ans.
					metaNameNextPos at: oldPos put: pos]
			ifFalse: [pos _ metaNameNextPos at: oldPos].
		^ ans! !

!MBootstrapMetaTokenizer methodsFor: 'productions' stamp: 'meta-auto 6/28/2007 21:44'!
metaSpecial
		| oldPos ans c horribleTrick |
		oldPos _ pos.
		(ans _ metaSpecialMemo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $<) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #<) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $>) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #>) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $?) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #?) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $() ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #'(') notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $)) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #')') notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $~) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #~) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $&) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #&) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $*) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #*) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $+) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #+) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $|) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #|) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $:) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $:) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $=) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #'::=') notNil]]]]]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $=) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $>) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #'=>') notNil]]]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $:) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ #:) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil]]]]]]]]]]]]]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					metaSpecialMemo at: oldPos put: ans.
					metaSpecialNextPos at: oldPos put: pos]
			ifFalse: [pos _ metaSpecialNextPos at: oldPos].
		^ ans! !

!MBootstrapMetaTokenizer methodsFor: 'productions' stamp: 'yo 2/28/2007 21:15'!
metaString
		| oldPos ans c s horribleTrick |
		oldPos _ pos.
		(ans _ metaStringMemo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $') ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (s _ [| tmp1 | tmp1 _ OrderedCollection new. [self savePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c ~= $') ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ c) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil] whileTrue: [self discardPos. tmp1 addLast: ans]. self restorePos; discardPos. ans _ tmp1 asArray] value)) notNil and: [(ans _ (c _ self char)) notNil and: [(ans _ ((c = $') ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ (String newFrom: s)) notNil]]]]]]) ifTrue: [ans] ifFalse: [nil]) notNil]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					metaStringMemo at: oldPos put: ans.
					metaStringNextPos at: oldPos put: pos]
			ifFalse: [pos _ metaStringNextPos at: oldPos].
		^ ans! !

!MBootstrapMetaTokenizer methodsFor: 'productions' stamp: 'yo 2/28/2007 21:15'!
metaSymbol
		| oldPos ans n s horribleTrick |
		oldPos _ pos.
		(ans _ metaSymbolMemo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ ans _ [| xyzSiZe xyzIndEx xyzMoreLoOp |
		xyzSiZe _ '#' size.
		xyzIndEx _ 0.
		self savePos.
		xyzMoreLoOp _ true.
		[
			xyzMoreLoOp and: [(xyzIndEx _ xyzIndEx + 1) <= xyzSiZe].
		] whileTrue: [
			horribleTrick _ self anything.
			horribleTrick ifNil: [xyzMoreLoOp _ false].
			horribleTrick = ('#' at: xyzIndEx) ifFalse: [xyzMoreLoOp _ false].
		].
		xyzMoreLoOp ifTrue: ['#'] ifFalse: [self restorePos; discardPos. nil]] value) notNil and: [(ans _ (n _ self metaName)) notNil and: [(ans _ MToken type: #symbol value: n symbol) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil or: [self restorePos. (ans _ (true and: [(ans _ ans _ [| xyzSiZe xyzIndEx xyzMoreLoOp |
		xyzSiZe _ '#' size.
		xyzIndEx _ 0.
		self savePos.
		xyzMoreLoOp _ true.
		[
			xyzMoreLoOp and: [(xyzIndEx _ xyzIndEx + 1) <= xyzSiZe].
		] whileTrue: [
			horribleTrick _ self anything.
			horribleTrick ifNil: [xyzMoreLoOp _ false].
			horribleTrick = ('#' at: xyzIndEx) ifFalse: [xyzMoreLoOp _ false].
		].
		xyzMoreLoOp ifTrue: ['#'] ifFalse: [self restorePos; discardPos. nil]] value) notNil and: [(ans _ (s _ self metaString)) notNil and: [(ans _ MToken type: #symbol value: (Symbol newFrom: s)) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil]]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					metaSymbolMemo at: oldPos put: ans.
					metaSymbolNextPos at: oldPos put: pos]
			ifFalse: [pos _ metaSymbolNextPos at: oldPos].
		^ ans! !

!MBootstrapMetaTokenizer methodsFor: 'productions' stamp: 'yo 2/28/2007 21:15'!
metaToken
		| oldPos ans horribleTrick |
		oldPos _ pos.
		(ans _ metaTokenMemo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ [| tmp1 | tmp1 _ OrderedCollection new. [self savePos. (ans _ self space) notNil] whileTrue: [self discardPos. tmp1 addLast: ans]. self restorePos; discardPos. ans _ tmp1 asArray] value) notNil and: [(ans _ [self savePos. false or: [self restorePos. (ans _ self metaSpecial) notNil or: [self restorePos. (ans _ self metaChar) notNil or: [self restorePos. (ans _ self metaString) notNil or: [self restorePos. (ans _ self metaSymbol) notNil or: [self restorePos. (ans _ self metaName) notNil or: [self restorePos. (ans _ self metaCode) notNil]]]]]]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value) notNil]]) ifTrue: [ans] ifFalse: [nil]) notNil]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					metaTokenMemo at: oldPos put: ans.
					metaTokenNextPos at: oldPos put: pos]
			ifFalse: [pos _ metaTokenNextPos at: oldPos].
		^ ans! !

!MBootstrapMetaTokenizer methodsFor: 'productions' stamp: 'meta-auto 6/28/2007 21:44'!
tokenize
		| oldPos ans horribleTrick |
		oldPos _ pos.
		(ans _ tokenizeMemo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ [| tmp1 | tmp1 _ OrderedCollection new. [self savePos. (ans _ self metaToken) notNil] whileTrue: [self discardPos. tmp1 addLast: ans]. self restorePos; discardPos. ans _ tmp1 asArray] value) notNil]) ifTrue: [ans] ifFalse: [nil]) notNil]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					tokenizeMemo at: oldPos put: ans.
					tokenizeNextPos at: oldPos put: pos]
			ifFalse: [pos _ tokenizeNextPos at: oldPos].
		^ ans! !

!MBootstrapParser class methodsFor: 'grammar handling' stamp: 'aw 2/19/2007 18:00'!
parse: aString with: aSymbol
	| tokens tree |
	tokens := self tokenizer match: aString with: #tokenize.
	tokens ifNil: [self inform: 'syntax error in ', aString. ^ nil].
	tree := self match: tokens with: aSymbol.
	tree ifNil: [self inform: 'syntax error in ', aString. ^ nil].
	^ tree.
! !

!MBootstrapParser class methodsFor: 'grammar handling' stamp: 'aw 2/18/2007 20:46'!
tokenizer
	^ self subclassResponsibility! !

!MBootstrapParser methodsFor: 'productions' stamp: 'aw 2/13/2007 18:28'!
char
		| oldPos ans  |
		oldPos _ pos.
		(ans _ charMemo at: pos) == Untried
			ifTrue: [ans _ self anything.
					ans isCharacter ifFalse: [ans _ nil].
					charMemo at: oldPos put: ans.
					charNextPos at: oldPos put: pos]
			ifFalse: [pos _ charNextPos at: pos].
		^ ans! !

!MBootstrapParser methodsFor: 'productions' stamp: 'aw 2/13/2007 17:08'!
end
		| oldPos ans  |
		oldPos _ pos.
		(ans _ endMemo at: pos) == Untried
			ifTrue: [ans _ self anything ifNotNil: [nil] ifNil: [true].
					endMemo at: oldPos put: ans].
		^ ans! !

!MBootstrapParser methodsFor: 'initializers' stamp: 'aw 2/13/2007 18:29'!
initializechar
	charMemo _ Array new: stream size + 1 withAll: Untried.
	charNextPos _ Array new: stream size + 1.
! !

!MBootstrapParser methodsFor: 'initializers' stamp: 'aw 2/13/2007 18:30'!
initializeend
	endMemo _ Array new: stream size + 1 withAll: Untried.
	endNextPos _ Array new: stream size + 1.
! !

!MBootstrapParser methodsFor: 'initializers' stamp: 'aw 2/14/2007 10:37'!
initializespace
	spaceMemo _ Array new: stream size + 1 withAll: Untried.
	spaceNextPos _ Array new: stream size + 1! !

!MBootstrapParser methodsFor: 'productions' stamp: 'aw 2/14/2007 10:37'!
space
		| oldPos ans c |
		oldPos _ pos.
		(ans _ spaceMemo at: pos) == Untried
			ifTrue: [ans _ [self savePos. false or: [self restorePos. (ans _ (true and: [(ans _ (c _ self char)) notNil and: [(ans _ (((c <= $ )) ifTrue: [true] ifFalse: [nil])) notNil and: [(ans _ c) notNil]]]) ifTrue: [ans] ifFalse: [nil]) notNil]. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value.
					spaceMemo at: oldPos put: ans.
					spaceNextPos at: oldPos put: pos]
			ifFalse: [pos _ spaceNextPos at: oldPos].
		^ ans! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/19/2007 17:34'!
addInstVarsForProduction: prodName
	| memoName nextPosName |
	memoName _ prodName, 'Memo'.
	nextPosName _ prodName, 'NextPos'.
	(self instVarNames includes: memoName)
		ifFalse: [self addInstVarName: memoName].
	(self instVarNames includes: nextPosName)
		ifFalse: [self addInstVarName: nextPosName].
! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/19/2007 17:36'!
addProduction: prodName withBody: body
	self addInstVarsForProduction: prodName.
	self compile: ('initialize{1}\	{1}Memo _ Array new: stream size + 1 withAll: Untried.\	{1}NextPos _ Array new: stream size + 1' withCRs format: {prodName}) classified: 'initializers'.
	^ self createNodeForProduction: prodName withBody: body.! !

!MMatcher class methodsFor: 'production generation' stamp: 'tfel 8/5/2016 12:43'!
addSupportForProduction: prodName
	self addInstVarsForProduction: prodName.
	self compile: ('initialize{1}\	{1}Memo _ Array new: stream size + 1 withAll: Untried.\	{1}NextPos _ Array new: stream size + 1' withCRs format: {prodName}) classified: 'initializers' withStamp: ('meta-auto ', Date today mmddyyyy, ' ',((String streamContents: [:s | Time now print24: true on: s]) copyFrom: 1 to: 5)) notifying: nil
! !

!MMatcher class methodsFor: 'production generation' stamp: 'yo 2/28/2007 20:57'!
createNodeForProduction: prodName withBody: body

	^ self compile: (self generateProduction: prodName withBody: body) notifying: nil.! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 2/14/2007 15:48'!
expand: aCollection

	^ self perform: aCollection first with: aCollection.
! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/13/2007 14:29'!
generateAndHelper: parts from: index into: aWriteStream
	index > parts size ifTrue: [^ self].
	aWriteStream
		nextPutAll: ' and: [(ans _ ';
		nextPutAll: (parts at: index);
		nextPutAll: ') notNil'.
	self generateAndHelper: parts from: index + 1 into: aWriteStream.
	aWriteStream nextPutAll: ']'.! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/13/2007 14:29'!
generateAnd: parts
	| w |
	w _ WriteStream on: (String new: parts size * 20).
	w nextPutAll: '(true'.
	self generateAndHelper: parts from: 1 into: w.
	w nextPutAll: ') ifTrue: [ans] ifFalse: [nil]'.
	^ w contents.! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/13/2007 15:03'!
generateAns: expr
	^ expr! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/13/2007 15:00'!
generateApp: prodName
	^ 'self ', prodName! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/13/2007 15:45'!
generateBind: varName to: expr
	userDefinedVars add: varName.
	^ '(', varName, ' _ ', expr, ')'
 ! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/13/2007 16:55'!
generateMany1: thing
	| acc |
	acc _ 'tmp', tmpIndex printString.
	tmpIndex _ tmpIndex + 1.
	^ '((ans _ {2}) notNil ifTrue: [| {1} | {1} _ OrderedCollection with: ans. [self savePos. (ans _ {2}) notNil] whileTrue: [self discardPos. {1} addLast: ans]. self restorePos; discardPos. ans _ {1}] ifFalse: [nil])' format: {acc. thing}.! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/13/2007 16:10'!
generateMany: thing
	| acc |
	acc _ 'tmp', tmpIndex printString.
	tmpIndex _ tmpIndex + 1.
	^ '[| {1} | {1} _ OrderedCollection new. [self savePos. (ans _ {2}) notNil] whileTrue: [self discardPos. {1} addLast: ans]. self restorePos; discardPos. ans _ {1}] value' format: {acc. thing}.! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/13/2007 14:56'!
generateNot: thing
	| w |
	w _ WriteStream on: (String new: thing size + 100).
	w nextPutAll: '[self savePos. ('; nextPutAll: thing; nextPutAll: ') ifNotNil: [self discardPos. nil] ifNil: [self restorePos; discardPos. true]] value'.
	^ w contents.! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/13/2007 17:42'!
generateOrHelper: parts from: index into: aWriteStream
	index > parts size ifTrue: [^ self].
	aWriteStream
		nextPutAll: ' or: [self restorePos. (ans _ ';
		nextPutAll: (parts at: index);
		nextPutAll: ') notNil'.
	self generateOrHelper: parts from: index + 1 into: aWriteStream.
	aWriteStream nextPutAll: ']'.! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/13/2007 16:04'!
generateOr: parts
	| w |
	w _ WriteStream on: (String new: parts size * 20).
	w nextPutAll: '[self savePos. false'.
	self generateOrHelper: parts from: 1 into: w.
	w nextPutAll: '. self discardPos. ans notNil ifTrue: [ans] ifFalse: [nil]] value'.
	^ w contents.! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/13/2007 15:51'!
generatePred: cond
	^ '((', cond, ') ifTrue: [true] ifFalse: [nil])'! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/13/2007 18:07'!
generateProduction: prodName withBody: body
	| vars |
	vars _ String streamContents: [:strm |
		userDefinedVars do: [:each | strm nextPutAll: each] separatedBy: [strm space]].
	^ '{1}
		| oldPos ans {3} |
		oldPos _ pos.
		(ans _ {1}Memo at: pos) == Untried
			ifTrue: [ans _ {2}.
					{1}Memo at: oldPos put: ans.
					{1}NextPos at: oldPos put: pos]
			ifFalse: [pos _ {1}NextPos at: oldPos].
		^ ans' format: {prodName. body. vars}.! !

!MMatcher class methodsFor: 'production generation' stamp: 'yo 5/17/2007 18:41'!
generateString: aString
	^ '[| xyzSiZe xyzIndEx xyzMoreLoOp |
		xyzSiZe _ {1} size.
		xyzIndEx _ 0.
		self savePos.
		xyzMoreLoOp _ true.
		[
			xyzMoreLoOp and: [(xyzIndEx _ xyzIndEx + 1) <= xyzSiZe].
		] whileTrue: [
			horribleTrick _ self anything.
			horribleTrick ifNil: [xyzMoreLoOp _ false].
			horribleTrick = ({1} at: xyzIndEx) ifFalse: [xyzMoreLoOp _ false].
		].
		xyzMoreLoOp ifTrue: [self discardPos. {1}] ifFalse: [self restorePos; discardPos. nil]] value' format: {aString storeString}.! !

!MMatcher class methodsFor: 'instance creation' stamp: 'aw 2/13/2007 11:53'!
initialize
"
	self initialize.
"
	Untried _ Object new.! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'yo 5/5/2007 14:52'!
macroAndP: aCollection
	| arg |
	arg _ self expand: aCollection second.
	^ '[self savePos. ({1})  ifNotNil: [self restorePos; discardPos. true] ifNil: [self discardPos. nil]] value' format: {arg}.! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 2/14/2007 15:59'!
macroAnd: aCollection

	^ self generateAnd: (self macroExpand: aCollection).
! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 2/18/2007 14:29'!
macroAns: aCollection

	^ aCollection second.
! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 2/14/2007 16:25'!
macroApp: aCollection
	| prodName |
	prodName _ aCollection second.
	^ 'self ', prodName.
! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 2/14/2007 16:23'!
macroBind: aCollection
	| aString value |
	aString _ aCollection second.
	value _ self expand: aCollection third.
	userDefinedVars add: aString.
	^ '(', aString, ' _ ', value, ')'.! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'yo 4/14/2007 17:56'!
macroCharacter: aCollection
	| aCharacter |
	aCharacter _ aCollection second.
	^ self expand: {#macroAnd:. {#macroBind:. 'horribleTrick'. {#macroApp:. 'char'}}. {#macroPred:. 'horribleTrick = ', aCharacter printString}. {#macroAns:. 'horribleTrick'}}
! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 2/19/2007 17:38'!
macroDef: aCollection
	|  prodBody |
	prodBody _ self expand: aCollection third.
	^ prodBody.! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 2/14/2007 15:58'!
macroExpand: aCollection

	^ (2 to: aCollection size) collect: [:idx |
		self expand: (aCollection at: idx)
	].
! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 3/1/2007 12:27'!
macroForm: aCollection
	| data prodName |
	data _ aCollection second.
	prodName _ aCollection third.
	^ self expand: {#macroAnd:.
					{#macroBind:. 'xyzaNs'. data}.
					{#macroPred:. 'xyzaNs isStream or: [xyzaNs isCollection and: [xyzaNs isSequenceable]]'}.
					{#macroAns:. 'self class match: xyzaNs with: #', prodName}.
				   }.! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 2/19/2007 02:51'!
macroInterval: aCollection
	| anInterval |
	anInterval _ aCollection second.
	^ self expand: {#macroAnd:.
					{#macroBind:. 'horribleTrick'. {#macroApp:. 'char'}}.
					{#macroPred:. 'horribleTrick >= ', anInterval start printString}.
					{#macroPred:. 'horribleTrick <= ', anInterval stop printString}.
					{#macroAns:. 'horribleTrick'}
				}.
! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'yo 2/21/2007 13:01'!
macroMany1: aCollection
	| acc thing |
	acc _ 'tmp', tmpIndex printString.
	tmpIndex _ tmpIndex + 1.
	thing _ self expand: aCollection second.
	^ '((ans _ {2}) notNil ifTrue: [| {1} | {1} _ OrderedCollection with: ans. [self savePos. (ans _ {2}) notNil] whileTrue: [self discardPos. {1} addLast: ans]. self restorePos; discardPos. ans _ {1} asArray] ifFalse: [nil])' format: {acc. thing}.! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'yo 2/21/2007 13:01'!
macroMany: aCollection
	| acc thing |
	acc _ 'tmp', tmpIndex printString.
	tmpIndex _ tmpIndex + 1.
	thing _ self expand: aCollection second.
	^ '[| {1} | {1} _ OrderedCollection new. [self savePos. (ans _ {2}) notNil] whileTrue: [self discardPos. {1} addLast: ans]. self restorePos; discardPos. ans _ {1} asArray] value' format: {acc. thing}.! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 2/14/2007 16:47'!
macroNot: aCollection
	| arg |
	arg _ self expand: aCollection second.
	^ '[self savePos. ({1})  ifNotNil: [self discardPos. nil] ifNil: [self restorePos; discardPos. true]] value' format: {arg}.! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 2/14/2007 15:59'!
macroOr: aCollection

	^ self generateOr: (self macroExpand: aCollection).
! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 2/15/2007 02:13'!
macroPred: aCollection
	| cond |
	cond _ aCollection second.
	^ '((', cond, ') ifTrue: [true] ifFalse: [nil])'.
! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'yo 5/17/2007 19:23'!
macroQuestion: aCollection

	^ self generateOr: (Array with: (self expand: aCollection second) with: (self expand: {#macroAns:. 'true'})).
! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'aw 2/14/2007 17:06'!
macroQuote: aCollection

	^ aCollection second.

! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'yo 2/23/2007 22:02'!
macroString: aCollection
	| aString parts |
	aString _ aCollection second.
	^ self generateString: aString.
! !

!MMatcher class methodsFor: 'macro expansion' stamp: 'yo 2/22/2007 11:07'!
macroSymbol: aCollection
	| aSymbol |
	aSymbol _ aCollection second.
	^ self expand: {#macroAnd:. {#macroBind:. 'horribleTrick'. {#macroApp:. 'anything'}}. {#macroPred:. 'horribleTrick = ', aSymbol printString}. {#macroAns:. 'horribleTrick'}}
! !

!MMatcher class methodsFor: 'grammar handling' stamp: 'aw 2/19/2007 17:58'!
match: aCollectionOrStream with: aSymbol
	^ (self on: aCollectionOrStream readStream) perform: aSymbol.! !

!MMatcher class methodsFor: 'instance creation' stamp: 'aw 2/12/2007 13:33'!
on: aStream
	| inst |
	inst _ self new.
	inst on: aStream.
	^ inst! !

!MMatcher class methodsFor: 'production generation' stamp: 'aw 2/14/2007 13:15'!
prepareForNewProduction
	userDefinedVars _ Set with: 'horribleTrick'.
	tmpIndex _ 1.! !

!MMatcher methodsFor: 'productions' stamp: 'aw 2/13/2007 18:14'!
anything
		|  oldPos ans |
		oldPos _ pos.
		(ans _ anythingMemo at: pos) == Untried
			ifTrue: [ans _ stream atEnd ifTrue: [nil] ifFalse: [pos _ pos + 1. stream next].
					anythingMemo at: oldPos put: ans.
					anythingNextPos at: oldPos put: pos]
			ifFalse: [pos _ anythingNextPos at: pos].
		^ ans! !

!MMatcher methodsFor: 'backtracking support' stamp: 'aw 2/12/2007 21:56'!
discardPos
	posStack removeLast! !

!MMatcher methodsFor: 'initializers' stamp: 'aw 2/13/2007 18:21'!
initializeanything

	anythingMemo _ Array new: stream size + 1 withAll: Untried.
	anythingNextPos _ Array new: stream size + 1.
! !

!MMatcher methodsFor: 'instance creation' stamp: 'aw 2/13/2007 16:28'!
on: aStream
	stream _ aStream.
	pos _ 1.
	posStack _ OrderedCollection new.
	((self class allSuperclasses copyUpTo: Object) copyWith: self class) do: [:cls |
		(cls organization listAtCategoryNamed: 'initializers') do: [:sel |
			self perform: sel]].
! !

!MMatcher methodsFor: 'backtracking support' stamp: 'aw 2/12/2007 21:56'!
restorePos
	pos _ posStack last! !

!MMatcher methodsFor: 'backtracking support' stamp: 'aw 2/12/2007 21:55'!
savePos
	posStack addLast: pos! !

MMatcher subclass: #MMeta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Implementation'!

!MMeta class methodsFor: 'compilation support' stamp: 'yo 2/21/2007 23:42'!
cleanUp

	| unused |
	unused _ self unusedInitializerNames.

	unused do: [:n |
		self removeSelector: n.
		self organization removeElement: n.
	].

	self removeInstVarNames: self unusedInstVarNames.
! !

!MMeta class methodsFor: 'compilation support' stamp: 'tfel 8/5/2016 15:46'!
compileAllFrom: oldClass
	"Compile all the methods in the receiver's method dictionary.
	This validates sourceCode and variable references and forces
	all methods to use the current bytecode set"
	"ar 7/10/1999: Use oldClass selectors not self selectors"
	(oldClass organization categories asSortedCollection: [:a :b | a = 'initializers']) do: [:cat |
		(oldClass organization listAtCategoryNamed: cat) do: [:sel |
			(oldClass selectors includes: sel) ifTrue: [
			self recompile: sel from: oldClass]]].
	super compileAllFrom: oldClass.! !

!MMeta class methodsFor: 'compilation support' stamp: 'aw 2/20/2007 17:26'!
compilerClass

	(self == MMeta) ifTrue: [^ super compilerClass].
	^ MMetaCompiler.
! !

!MMeta class methodsFor: 'grammar handling' stamp: 'aw 2/20/2007 17:47'!
parse: aString with: aSymbol
	| tokens tree |
	tokens := self tokenizer match: aString with: #tokenize.
	tokens ifNil: [self inform: 'syntax error in ', aString. ^ nil].
	tree := self match: tokens with: aSymbol.
	tree ifNil: [self inform: 'syntax error in ', aString. ^ nil].
	^ tree.
! !

!MMeta class methodsFor: 'grammar handling' stamp: 'aw 2/20/2007 17:46'!
tokenizer
	^ self subclassResponsibility! !

!MMeta class methodsFor: 'private' stamp: 'yo 2/21/2007 23:39'!
unusedInitializerNames

	| initializeSize selectors result prodName |
	initializeSize _ 'initialize' size.
	selectors _ self selectors.
	selectors addAll: (self organization listAtCategoryNamed: 'initializers').
	result _ Set new: selectors size.
	selectors asArray do: [:sel |
		(sel size > initializeSize and: [sel beginsWith: 'initialize']) ifTrue: [
			prodName _ (sel copyFrom: initializeSize + 1 to: sel size) asSymbol.
			(selectors includes: prodName) ifFalse: [
				result add: sel.
			]
		]
	].
	^ result.
! !

!MMeta class methodsFor: 'private' stamp: 'yo 2/21/2007 17:01'!
unusedInstVarNames

	| memoSize nextPosSize prodName selectors result |
	memoSize _ 'Memo' size.
	nextPosSize _ 'NextPos' size.
	selectors _ self selectors.
	result _ Set new: selectors size.
	self instVarNames do: [:var |
		(var size > nextPosSize and: [var endsWith: 'NextPos']) ifTrue: [
			prodName _ (var copyFrom: 1 to: var size - nextPosSize) asSymbol.
			(selectors includes: prodName) ifFalse: [
				result add: var.
			]
		].
		(var size > memoSize and: [var endsWith: 'Memo']) ifTrue: [
			prodName _ (var copyFrom: 1 to: var size - memoSize) asSymbol.
			(selectors includes: prodName) ifFalse: [
				result add: var.
			]
		]
	].

	^ result.
! !

!MMeta class methodsFor: 'private' stamp: 'yo 2/21/2007 16:57'!
unusedProductionNames

	| initializeSize selectors result prodName memoSize nextPosSize |
	initializeSize _ 'initialize' size.
	selectors _ self selectors.
	result _ Set new: selectors size.
	selectors asArray do: [:sel |
		(sel size > initializeSize and: [sel beginsWith: 'initialize']) ifTrue: [
			prodName _ (sel copyFrom: initializeSize + 1 to: sel size) asSymbol.
			(selectors includes: prodName) ifFalse: [
				result add: prodName.
			]
		]
	].

	memoSize _ 'Memo' size.
	nextPosSize _ 'NextPos' size.
	self instVarNames do: [:var |
		(var size > nextPosSize and: [var endsWith: 'NextPos']) ifTrue: [
			prodName _ (var copyFrom: 1 to: var size - nextPosSize) asSymbol.
			(selectors includes: prodName) ifFalse: [
				result add: prodName.
			]
		].
		(var size > memoSize and: [var endsWith: 'Memo']) ifTrue: [
			prodName _ (var copyFrom: 1 to: var size - memoSize) asSymbol.
			(selectors includes: prodName) ifFalse: [
				result add: prodName.
			]
		]
	].

	^ result.
! !

Object subclass: #MToken
	instanceVariableNames: 'type value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Implementation'!

!MToken class methodsFor: 'instance creation' stamp: 'yo 2/28/2007 21:09'!
type: aSymbol value: val

	^ self new type: aSymbol value: val.
! !

!MToken methodsFor: 'all' stamp: 'yo 2/28/2007 21:28'!
hash
	^ value hash + type hash
! !

!MToken methodsFor: 'all' stamp: 'yo 2/28/2007 20:26'!
is: aSymbol

	^ type == aSymbol! !

!MToken methodsFor: 'all' stamp: 'aw 3/1/2007 12:17'!
printOn: aStream

	aStream nextPutAll: 'MToken(';
		nextPutAll: type; space;
		nextPutAll: value asString;
		nextPutAll: ')'
! !

!MToken methodsFor: 'all' stamp: 'yo 2/28/2007 21:27'!
type

	^ type.
! !

!MToken methodsFor: 'all' stamp: 'yo 2/28/2007 20:26'!
type: aSymbol value: val

	type _ aSymbol.
	value _ val.
! !

!MToken methodsFor: 'all' stamp: 'yo 2/28/2007 20:26'!
value

	^ value.
! !

!MToken methodsFor: 'all' stamp: 'yo 2/28/2007 21:27'!
= other
	(other isMemberOf: MToken) ifFalse: [^ false].
	^ type = other type and: [value = other value].
! !
MMatcher initialize!
